package com.fs.starfarer.api.impl.campaign.rulecmd;

import com.fs.starfarer.api.ui.TooltipMakerAPI;
import com.fs.starfarer.api.campaign.ReputationActionResponsePlugin;
import com.fs.starfarer.api.campaign.comm.CommMessageAPI;
import com.fs.starfarer.api.impl.campaign.CoreReputationPlugin;
import kaysaar.aotd_question_of_loyalty.data.scripts.commision.AoTDCommissionUtil;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import kaysaar.aotd_question_of_loyalty.data.scripts.AoTDPensionFund;
import kaysaar.aotd_question_of_loyalty.data.scripts.fleets.TraitorBountyFleetApplier;
import kaysaar.aotd_question_of_loyalty.data.models.AoTDHandleBonusesFromBeingRetired;
import kaysaar.aotd_question_of_loyalty.data.scripts.commision.FactionHatredManager;
import kaysaar.aotd_question_of_loyalty.data.models.RetirementInfo;
import com.fs.starfarer.api.impl.campaign.intel.FactionCommissionIntel;
import kaysaar.aotd_question_of_loyalty.data.models.BaseFactionCommisionData;
import kaysaar.aotd_question_of_loyalty.data.scripts.commision.AoTDCommissionDataManager;
import java.util.Iterator;
import com.fs.starfarer.api.campaign.econ.MarketAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.fleet.FleetMemberAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.rules.MemoryAPI;
import java.util.Map;
import com.fs.starfarer.api.util.Misc;
import java.util.List;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.impl.campaign.rulecmd.missions.Commission;

public class AoTDCommision extends Commission
{
    public static String isHatedByFactionMemKey;
    
    public boolean execute(final String ruleId, final InteractionDialogAPI dialog, final List<Misc.Token> params, final Map<String, MemoryAPI> memoryMap) {
        this.dialog = dialog;
        this.memoryMap = memoryMap;
        final String command = params.get(0).getString((Map)memoryMap);
        if (command == null) {
            return false;
        }
        if (command.equals("canResign")) {
            return this.canResign();
        }
        if (command.equals("canColonize")) {
            return this.canColonize();
        }
        this.memory = getEntityMemory((Map)memoryMap);
        this.entity = dialog.getInteractionTarget();
        this.text = dialog.getTextPanel();
        this.options = dialog.getOptionPanel();
        this.playerFleet = Global.getSector().getPlayerFleet();
        this.playerFaction = Global.getSector().getPlayerFaction();
        this.entityFaction = this.entity.getFaction();
        this.person = dialog.getInteractionTarget().getActivePerson();
        this.faction = this.person.getFaction();
        this.offersCommissions = this.faction.getCustomBoolean("offersCommissions");
        if (command.equals("retiredFromThatFaction")) {
            return Global.getSector().getMemory().getString(AoTDRetirementOption.memKey).equals(this.faction.getId());
        }
        if (command.equals("printRequirements")) {
            this.printRequirements();
        }
        else {
            if (command.equals("playerMeetsCriteria")) {
                return this.playerMeetsCriteria();
            }
            if (command.equals("isCommissionedByPersonFaction")) {
                return QoLMisc.isCommissionedBy(this.faction.getId());
            }
            if (command.equals("isStillWaiting")) {
                return this.playerFleet.getMemory().is("$aotd_wait_for_resupply", true);
            }
            if (command.equals("printResponse")) {
                this.printResponseForWantingToResupply();
            }
            else if (command.equals("printInfo")) {
                this.printInfo();
            }
            else {
                if (command.equals("hasFactionCommission")) {
                    return this.hasFactionCommission();
                }
                if (command.equals("hasOtherCommission")) {
                    if (this.hasOtherCommission()) {
                        this.memory.set("$theOtherCommissionFaction", (Object)Misc.getCommissionFaction().getDisplayNameWithArticle(), 0.0f);
                        this.memory.set("$otherCommissionFaction", (Object)Misc.getCommissionFaction().getPersonNamePrefix(), 0.0f);
                        return true;
                    }
                    return false;
                }
                else if (command.equals("接受")) {
                    this.接受();
                }
                else if (command.equals("辞职")) {
                    this.辞职(true);
                }
                else if (command.equals("resignNoPenalty")) {
                    this.辞职(false);
                }
                else {
                    if (command.equals("isSteppingIntoNoReturn")) {
                        return this.isSteppingIntoNoReturn();
                    }
                    if (command.equals("personCanGiveCommission")) {
                        return this.personCanGiveCommission();
                    }
                    if (command.equals("commissionFactionIsAtWarWith")) {
                        if (this.hasOtherCommission() && params.size() >= 1) {
                            final String target_faction_id = params.get(0).getString((Map)memoryMap);
                            final FactionAPI target_faction = Global.getSector().getFaction(target_faction_id);
                            if (target_faction != null) {
                                return Misc.getCommissionFaction().isHostileTo(target_faction);
                            }
                        }
                        return false;
                    }
                    if (command.equals("isCargoPodsScam")) {
                        final MarketAPI market = dialog.getInteractionTarget().getMarket();
                        if (market == null) {
                            return false;
                        }
                        for (final SectorEntityToken entity : market.getContainingLocation().getAllEntities()) {
                            if ("cargo_pods".equals(entity.getCustomEntityType())) {
                                final float dist = Misc.getDistance(entity.getLocation(), this.playerFleet.getLocation());
                                if (dist < 500.0f && entity.getCargo().getSupplies() >= 10.0f) {
                                    return true;
                                }
                                continue;
                            }
                        }
                        return false;
                    }
                    else if (command.equals("recalcFreeSupplyDaysRemaining")) {
                        final Object obj1 = this.person.getFaction().getMemoryWithoutUpdate().get("$playerReceivedCommissionResupplyOn");
                        final Object obj2 = Global.getSector().getMemoryWithoutUpdate().get("$daysSinceStart");
                        if (obj1 == null) {
                            return false;
                        }
                        if (obj2 == null) {
                            return false;
                        }
                        final float d1 = (float)obj1;
                        final float d2 = (float)obj2;
                        this.faction.getMemoryWithoutUpdate().set("$daysLeft", (Object)((int)d1 + 365 - (int)d2), 0.0f);
                    }
                    else if (command.equals("doesPlayerFleetNeedRepairs")) {
                        float fleetCRcurrent = 0.0f;
                        float fleetCRmax = 0.0f;
                        float fleetHullDamage = 0.0f;
                        for (final FleetMemberAPI member : this.playerFleet.getMembersWithFightersCopy()) {
                            if (member.isFighterWing()) {
                                continue;
                            }
                            fleetHullDamage += 1.0f - member.getStatus().getHullFraction();
                            fleetCRcurrent += member.getRepairTracker().getCR();
                            fleetCRmax += member.getRepairTracker().getMaxCR();
                        }
                        boolean needsSupplies = false;
                        if (fleetHullDamage > 0.5) {
                            needsSupplies = true;
                            Global.getSector().getPlayerMemoryWithoutUpdate().set("$fleetDamaged", (Object)true, 0.0f);
                        }
                        if (fleetHullDamage > 2.5) {
                            needsSupplies = true;
                            Global.getSector().getPlayerMemoryWithoutUpdate().set("$fleetDamagedLots", (Object)true, 0.0f);
                        }
                        if (fleetCRcurrent == 0.0f || fleetCRcurrent / fleetCRmax < 0.6f) {
                            needsSupplies = true;
                            Global.getSector().getPlayerMemoryWithoutUpdate().set("$fleetLowCR", (Object)true, 0.0f);
                        }
                        return needsSupplies;
                    }
                }
            }
        }
        return true;
    }
    
    protected void 接受() {
        if (Misc.getCommissionFactionId() == null) {
            BaseFactionCommisionData data = AoTDCommissionDataManager.getInstance().getCommisionData(this.faction.getId());
            if (data == null) {
                data = BaseFactionCommisionData.getDefaultCommisionData(this.faction.getId());
            }
            final AoTDCommIntelPlugin intel = data.getPlugin();
            intel.initializeFully(data, this.text, false, data.getFirstDefRank(), data.getFirstOfficialRank());
            intel.sendUpdate((Object)FactionCommissionIntel.UPDATE_PARAM_ACCEPTED, this.dialog.getTextPanel());
            Global.getSector().getCharacterData().getMemoryWithoutUpdate().set("$fcm_faction", (Object)this.faction.getId());
            if (intel.hasRetiredFromAnyFaction() && !intel.hasRetiredFromFaction()) {
                final FactionAPI factionAPI = Global.getSector().getFaction(RetirementInfo.getInstance().getPrevFaction());
                intel.makeVengeful(factionAPI, this.dialog);
                FactionHatredManager.get().addFactionThatHatePlayer(factionAPI.getId());
                AoTDHandleBonusesFromBeingRetired.unapplyBonusesFromRetirement(this.dialog);
                TraitorBountyFleetApplier.triggerTreasonFleets(factionAPI.getId());
                Global.getSector().getListenerManager().removeListenerOfClass((Class)AoTDPensionFund.class);
            }
            AoTDHandleBonusesFromBeingRetired.unapplyBonusesFromRetirement(this.dialog);
            AoTDHandleBonusesFromBeingRetired.unapplyTTDeal(this.dialog, this.faction);
            intel.makeRepChanges(this.dialog);
            for (final MarketAPI playerMarket : Misc.getPlayerMarkets(false)) {
                AoTDCommIntelPlugin.setMarketFaction(playerMarket, this.faction.getId(), true);
            }
            AoTDCommissionUtil.reportPlayerGotNewRank(intel.getCurrentRankData());
        }
    }
    
    public void printResponseForWantingToResupply() {
        this.getPluginForFaction().printSuppliesForTaking(this.dialog);
    }
    
    public void giveSupplies() {
    }
    
    protected boolean playerMeetsCriteria() {
        return this.getPluginForFaction().doesPlayerMeetCriteriaForCommision();
    }
    
    protected void 辞职(final boolean withPenalty) {
        final CoreReputationPlugin.CustomRepImpact impact = new CoreReputationPlugin.CustomRepImpact();
        impact.delta = -1.0f * AoTDCommIntelPlugin.get().getCurrentRankData().getPenaltyForLeaving();
        final ReputationActionResponsePlugin.ReputationAdjustmentResult rep = Global.getSector().adjustPlayerReputation((Object)new CoreReputationPlugin.RepActionEnvelope(CoreReputationPlugin.RepActions.CUSTOM, (Object)impact, (CommMessageAPI)null, (this.dialog != null) ? this.dialog.getTextPanel() : null, false, true), this.faction.getId());
        AoTDCommIntelPlugin.get().endCommision(this.dialog, false);
        Global.getSector().getMemoryWithoutUpdate().unset(AoTDCommIntelPlugin.RESEARCH_KEY);
        Global.getSector().getCharacterData().getMemory().unset("$fcm_faction");
    }
    
    protected void printInfo() {
        final TooltipMakerAPI info = this.dialog.getTextPanel().beginTooltip();
        this.getPluginForFaction().printInfo(this.dialog, info);
    }
    
    public boolean canResign() {
        return AoTDCommIntelPlugin.get() != null && AoTDCommIntelPlugin.get().canResign();
    }
    
    public boolean isSteppingIntoNoReturn() {
        return this.getPluginForFaction().isSteppingIntoNoReturn();
    }
    
    public AoTDCommIntelPlugin getPluginForFaction() {
        return AoTDCommissionDataManager.getInstance().getCommisionData(this.faction.getId()).getPlugin();
    }
    
    public boolean canColonize() {
        return AoTDCommIntelPlugin.get() == null || AoTDCommIntelPlugin.get().canColonize();
    }
    
    protected void printRequirements() {
        this.getPluginForFaction().printRequirements(this.dialog);
    }
    
    static {
        AoTDCommision.isHatedByFactionMemKey = "$aotd_treason";
    }
}
